/***************************************************************/
/*                       rank.c                                */
/*　ngram의 빈도분포를 작성합니다                              */
/*　　　입력은 표준입력으로 주고 출력은 표준출력으로 출력합니다*/
/* 사용방법                                                    */
/*  $./rank < (입력파일명）> (출력파일명)                      */
/*　입력파일에는 ngram 파일을 지정합니다                       */
/*　출력파일에는 빈도분포를 출력합니다                         */
/***************************************************************/

/* 헤더파일 포함 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* 기호상수 정의 */
#define N 32 /* ngram의 최대길이 */
#define ITEMNO 65535*3 /* ngram의 최대개수  */
#define NUMF 4 /* 추가하는 수치 필드의 크기 */

/* 함수의 프로토타입 선언 */
int uniq(int n,char ngram[ITEMNO][N]
               ,char result[ITEMNO][N+NUMF]) ; /* 중복을 모은다 */
int rescmp(const char *a,const char *b) ;      /* 비교함수 */

/* 외부변수 정의 */
char ngram[ITEMNO][N];        /* ngram 등을 저장하는 변수 */
char result[ITEMNO][N+NUMF] ; /* ngram 등을 저장하는 변수 */


/*******************/
/*    main() 함수  */
/*******************/
int main(int argc,char *argv[])
{
 int i,j ; /* 반복의 제어문자 */
 int no ; /* 출력 개수 */

 /* ngram 읽기 */
 i=0 ;
 while(fgets(ngram[i],N,stdin) != NULL){
  if(i>=ITEMNO){/* ngram이 최대수에 달했다. */
   fprintf(stderr,"ngram이 최대수에 도달했습니다.\n") ;
   break ;
  }
  ++i ;
 }
 /* 사전 순으로 정렬 */
 qsort(ngram,i,N,
     (int (*)(const void *,const void *))strcmp) ; 
 /* 중복을 보은다 */
 no=uniq(i,ngram,result) ;
 /* 빈도 순으로 정렬 */
 qsort(result,no,N+NUMF,
     (int (*)(const void *,const void *))rescmp) ; 

 /* 결과 출력 */
 for(j=0;j<i;++j) printf("%s",result[j]) ;
 
 return 0 ;
}

/*******************/
/*  uniq() 함수    */
/* 중복을 모은다   */
/*******************/
int uniq(int n,char ngram[ITEMNO][N]
                ,char result[ITEMNO][N+NUMF])
{
 int i,j ;/* 처리 카운터 */
 int c ;/* 중복을 계산하는 변수 */ 
 char lastgram[N] ;/* 직전의 ngram */ 

 /* 초기화 */
 strncpy(lastgram,ngram[0],N) ;
 j=0 ;
 c=1 ;

 /* 중복처리 */ 
 for(i=1;i<n;++i){
  if(strcmp(lastgram,ngram[i])==0){
   /* ngram이 중복 */
   ++ c ;/* 카운트 */
  }else{
   /* 결과 배열에 값을 삽입 */
   sprintf(result[j],"%d\t%s",c,lastgram) ;
   strncpy(lastgram,ngram[i],N) ;
   c=1 ;
   ++j ;
  }
 }
 /* 결과 배열에 값을 삽입 */
 sprintf(result[j],"%d\t%s",c,lastgram) ;
 strncpy(lastgram,ngram[i],N) ;
 ++j ;
 return j ; 
}
      
/*******************/
/* rescmp() 함수   */
/* 비교함수        */
/*******************/
int rescmp(const char *a,const char *b)
{
 int numa,numb ;
 /* 선두 숫자를 수치로 변환 */
 numa=atoi(a) ; numb=atoi(b) ;
 /* 비교결과를 반환값으로 한다 */
 if(numa>numb) return -1 ;
 else if(numa<numb) return 1 ;
 else return 0 ;
}




