/********************************************************/
/*                       puzzle.c                       */
/*　퍼즐의 해를 구하는 프로그램 　　                    */
/* 사용방법                                             */
/*       $./puzzle                                      */
/********************************************************/

/* 헤더 파일 포함 */
#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

/* 기호 상수 정의 */
#define DATANO 20   /* 데이터 수 */
#define VALUE 499   /* 목표치 */

/* 함수의 프로토타입 선언 */
int evalfit(int g[]) ; /* 적응도 계산 */
int inc(int g[]) ; /* 제어배열 증가 */
void printg(int g[],int fitness) ; /* 결과 출력*/

/* 문제의 수치 설정 */
int q[]={31,41,59,26,53,58,97,93,23,84,
         -62,-64,-33,-83,-27,-95,-2,-88,-41,-97} ;

/*******************/
/*    main()함수   */
/*******************/
int main(int argc,char *argv[])
{
 int g[DATANO]={0} ; /* 반복 제어 변수 */
 int bestfitness=INT_MAX ; /* 적응도의 최적치 */
 int fitness ;/* 현재의 적응도 */

 /* 모든 경우의 조합을 생성 */
 while(inc(g)==0){/* 마지막 자리 올림이 있을 때까지 반복 */
  fitness=evalfit(g) ;
  if(abs(fitness)<=abs(bestfitness)){
   bestfitness=fitness ;/* 갱신 */
   printg(g,fitness) ;/* 결과 출력 */
  }
 }
 
 return 0 ;
}

/************************/
/*   evalfit()함수      */
/*   적응도 계산        */
/************************/
int evalfit(int g[])
{
 int i ;/* 반복 제어 변수 */
 int fitness=0 ;/* 적응도 도중값 */

 for(i=0;i<DATANO;++i)
  fitness+=g[i]*q[i] ;

 return VALUE-fitness ;
}

/***********************/
/*   inc()함수         */
/*  g[]증가          */
/***********************/
int inc(int g[])
{
 int i ;/* 반복 제어 변수 */
 int carry=1 ;/* 자리올림 값 */

 for(i=0;i<DATANO;++i){
  g[i]+=carry ;
  carry=0 ;
  if(g[i]>1){
   g[i]=0 ;
   carry=1 ;
  }
 } 

 return carry;
}

/***********************/
/*   printg()함수      */
/*   결과출력          */
/***********************/
void printg(int g[],int fitness)
{
 int i ;/* 반복 제어 변수 */

 for(i=0;i<DATANO;++i)
  printf("%1d",g[i]) ;
 printf("\t%d\n",fitness) ;
}

